// Stuck in the public domain with No strings attached by
// MatrixRat.
//************************************************************
// last thing playedwith, easy to find here
int ElementOffset = 0;
//***********************************************************
// Here's what drives the 16 encoders.
// Have run this on a T3.6 without the shift registers connected and their absence
// does not adversely affect operation.
#include "EncoderTool.h"
using namespace EncoderTool;
constexpr unsigned        QH_A   = 17; //output pin QH of shift register B - Encoder B
constexpr unsigned        QH_B   = 16; //output pin QH of shift register A - Encoder A
constexpr unsigned        QH_C   = 15; //output pin QH of shift register C - Buttons
constexpr unsigned        pinLD  = 4; //load pin for all shift registers)
constexpr unsigned        pinCLK = 5; //clock pin for all shift registers
constexpr unsigned encoderCount = 16; // number of attached  (daisy chain shift regesters for more than 8)
int encoderData[encoderCount];
int encoderDataLag[encoderCount];// when lag and new are not the same then update MIDI CC value
EncPlex74165 encoders(encoderCount, pinLD, pinCLK, QH_A, QH_B );
//**********************************************************
// For Block select encoder. Using here in CountMode::quarter given that is used to select
// Blocks 1-10 with a non-detented 96 ppr unit. Instantiated in void setup()
// so simply hook up a single encoder here to switch Blocks
// No frills, just wire it up, no neeed for caps
// Thanks @Luni
#define ENC_PINA  14
#define ENC_PINB   6

//***********************************************************
//  EncoderTool MUST come first to avoid compiler whining

#include <ILI9341_t3.h>           // fast display driver lib
#include "UTouch.h"               // touchscreen lib
#include <ILI9341_t3_Controls.h>  // custom control define file

//One-stop hardware details shop
#define TFT_DC     9              // DC pin on LCD
#define TFT_CS    10              // chip select pin on LCD
#define LCD_PIN   32              // lcd pin to control brightness
#define TOUCH_CLK 24
#define TOUCH_CS  25
#define TOUCH_DIN 26
#define TOUCH_DO  27
#define TOUCH_IRQ 28
#define Rotation   3
//Uncomment the one you want
//#define USE_YELLOW_HEADERS
#define USE_BLACK_HEADERS

//********************************************************
// Appropriated and hacked this from Notes and Volts Midi controller
#include "SliderElements.h"

//minVal,maxVal,currVal,oldVal,float tick,float snap,slideColor,backColor,handleColor,handleShape,HandleSize,controlOffValue, defaultKeySent,lastSent,byte toggleState);

SliderElement E1   (0, 127,  17,  0, 16.0, 1.0, 1,  0, 3, 1, 12, 0, 127, 0, 255);
SliderElement E2   (0, 127,  21,  0, 16.0, 1.0, 1,  0, 3, 2, 12, 0, 127, 0, 255);
SliderElement E3   (0, 255,  31,  0, 16.0, 1.0, 1,  0, 3, 3, 12, 0, 127, 0, 255);
SliderElement E4   (0, 127,  47,  0, 16.0, 1.0, 1,  0, 3, 4, 12, 0, 127, 0, 255);
SliderElement E5   (0, 127,  55,  0, 16.0, 1.0, 1,  0, 3, 5, 12, 0, 127, 0, 255);
SliderElement E6   (0, 127,  63,  0, 16.0, 1.0, 1,  0, 3, 6, 12, 0, 127, 0, 255);
SliderElement E7   (0, 127,  71,  0, 16.0, 1.0, 1,  0, 3, 2, 12, 0, 127, 0, 255);
SliderElement E8   (0, 127,  89,  0, 16.0, 1.0, 1,  0, 3, 2, 12, 0, 127, 0, 255);

SliderElement E9   (0, 127,  95,  0, 16.0, 1.0, 5,  0, 6, 3, 10, 0, 127, 0, 255);
SliderElement E10  (0, 127,  103, 0, 16.0, 1.0, 5,  0, 6, 3, 10, 0, 127, 0, 255);
SliderElement E11  (0, 127,  121, 0, 16.0, 1.0, 5,  0, 6, 3, 10, 0, 127, 0, 255);
SliderElement E12  (0, 127,  22,  0, 16.0, 1.0, 5,  0, 6, 3, 10, 0, 127, 0, 255);
SliderElement E13  (0, 127,  24,  0, 16.0, 1.0, 5,  0, 6, 4, 10, 0, 127, 0, 255);
SliderElement E14  (0, 127,  26,  0, 16.0, 1.0, 5,  0, 6, 4, 10, 0, 127, 0, 255);
SliderElement E15  (0, 127,  28,  0, 16.0, 1.0, 5,  0, 6, 4, 10, 0, 127, 0, 255);
SliderElement E16  (0, 127,  30,  0, 16.0, 1.0, 5,  0, 6, 4, 10, 0, 127, 0, 255);

SliderElement E17  (0, 255,  32,  0, 32.0, 1.0, 7,  0, 0, 5, 10, 0, 127, 0, 255);
SliderElement E18  (0, 255,  34,  0, 32.0, 1.0, 6,  0, 1, 5, 10, 0, 127, 0, 255);
SliderElement E19  (0,  17,   9,  0,  1.0, 1.0, 5,  0, 2, 5, 10, 0, 127, 0, 255);
SliderElement E20  (0,   5,   3,  0,  1.0, 1.0, 4,  0, 3, 5, 10, 0, 127, 0, 255);
SliderElement E21  (0,  11,   4,  0,  1.0, 1.0, 3,  0, 4, 4, 10, 0, 127, 0, 255);
SliderElement E22  (0,  63,  42,  0, 16.0, 1.0, 2,  0, 5, 4, 10, 0, 127, 0, 255);
SliderElement E23  (0, 127,  44,  0, 16.0, 1.0, 1,  0, 6, 4, 10, 0, 127, 0, 255);
SliderElement E24  (0, 127,  46,  0, 16.0, 1.0, 0,  0, 7, 4, 10, 0, 127, 0, 255);

SliderElement E25  (0, 127,  48,  0, 16.0, 1.0, 19,  0, 7, 3, 14, 0, 127, 0, 255);
SliderElement E26  (0, 127,  50,  0, 16.0, 1.0, 18,  0, 6, 3, 14, 0, 127, 0, 255);
SliderElement E27  (0, 127,  52,  0, 16.0, 1.0, 17,  0, 5, 3, 14, 0, 127, 0, 255);
SliderElement E28  (0, 127,  54,  0, 16.0, 1.0, 16,  0, 4, 3, 14, 0, 127, 0, 255);
SliderElement E29  (0, 127,  56,  0, 16.0, 1.0, 15,  0, 3, 1, 14, 0, 127, 0, 255);
SliderElement E30  (0, 127,  58,  0, 16.0, 1.0, 14,  0, 2, 2, 14, 0, 127, 0, 255);
SliderElement E31  (0, 127,  60,  0, 16.0, 1.0, 13,  0, 1, 3, 14, 0, 127, 0, 255);
SliderElement E32  (0, 127,  62,  0, 16.0, 1.0, 12,  0, 1, 4, 14, 0, 127, 0, 255);

SliderElement E33  (0, 127,  64,  0, 16.0, 1.0, 12,  0, 2, 4, 16, 0, 127, 0, 255);
SliderElement E34  (0, 127,  66,  0, 16.0, 1.0, 12,  0, 6, 3, 15, 0, 127, 0, 255);
SliderElement E35  (0, 127,  68,  0, 16.0, 1.0, 12,  0, 6, 2, 12, 0, 127, 0, 255);
SliderElement E36  (0, 127,  70,  0, 16.0, 1.0, 12,  0, 6, 3, 14, 0, 127, 0, 255);
SliderElement E37  (0, 127,  72,  0, 16.0, 1.0, 12,  0, 6, 1, 30, 0, 127, 0, 255);
SliderElement E38  (0, 127,  89,  0, 16.0, 1.0, 20,  0, 7, 2, 10, 0, 127, 0, 255);
SliderElement E39  (0, 127,  95,  0, 16.0, 1.0, 21,  0, 3, 3, 10, 0, 127, 0, 255);
SliderElement E40  (0, 127,  103, 0, 16.0, 1.0, 22,  0, 2, 3, 10, 0, 127, 0, 255);

SliderElement E41  (0, 127,  121, 0, 16.0, 1.0, 13,  0, 3, 3, 10, 0, 127, 0, 255);
SliderElement E42  (0, 127,  22,  0, 16.0, 1.0, 14,  0, 3, 3, 10, 0, 127, 0, 255);
SliderElement E43  (0, 127,  24,  0, 16.0, 1.0, 12,  0, 3, 4, 10, 0, 127, 0, 255);
SliderElement E44  (0, 127,  26,  0, 16.0, 1.0, 11,  0, 4, 4, 10, 0, 127, 0, 255);
SliderElement E45  (0, 127,  28,  0, 16.0, 1.0, 10,  0, 4, 4, 10, 0, 127, 0, 255);
SliderElement E46  (0, 127,  30,  0, 16.0, 1.0, 10,  0, 5, 4, 10, 0, 127, 0, 255);
SliderElement E47  (0, 127,  32,  0, 16.0, 1.0, 27,  0, 1, 0, 13, 0, 127, 0, 255);
SliderElement E48  (0, 127,  34,  0, 16.0, 1.0, 26,  0, 2, 0, 13, 0, 127, 0, 255);

SliderElement E49  (0, 127,  36,  0, 16.0, 1.0, 25,  0, 3, 0, 13, 0, 127, 0, 255);
SliderElement E50  (0, 127,  38,  0, 16.0, 1.0, 24,  0, 4, 0, 13, 0, 127, 0, 255);
SliderElement E51  (0, 127,  40,  0, 16.0, 1.0, 23,  0, 5, 2, 13, 0, 127, 0, 255);
SliderElement E52  (0, 127,  42,  0, 16.0, 1.0, 22,  0, 6, 2, 13, 0, 127, 0, 255);
SliderElement E53  (0, 127,  44,  0, 16.0, 1.0, 21,  0, 7, 2, 13, 0, 127, 0, 255);
SliderElement E54  (0, 127,  46,  0, 16.0, 1.0, 20,  0, 8, 2, 13, 0, 127, 0, 255);
SliderElement E55  (0, 127,  48,  0, 16.0, 1.0, 19,  0, 7, 3, 14, 0, 127, 0, 255);
SliderElement E56  (0, 127,  50,  0, 16.0, 1.0, 18,  0, 6, 3, 14, 0, 127, 0, 255);

SliderElement E57  (0, 127,  52,  0, 16.0, 1.0, 17,  0, 5, 3, 14, 0, 127, 0, 255);
SliderElement E58  (0, 127,  54,  0, 16.0, 1.0, 16,  0, 4, 3, 14, 0, 127, 0, 255);
SliderElement E59  (0, 127,  56,  0, 16.0, 1.0, 15,  0, 3, 1, 14, 0, 127, 0, 255);
SliderElement E60  (0, 127,  58,  0, 16.0, 1.0, 14,  0, 2, 2, 14, 0, 127, 0, 255);
SliderElement E61  (0, 127,  60,  0, 16.0, 1.0, 13,  0, 1, 3, 14, 0, 127, 0, 255);
SliderElement E62  (0, 127,  62,  0, 16.0, 1.0, 12,  0, 1, 4, 14, 0, 127, 0, 255);
SliderElement E63  (0, 127,  64,  0, 16.0, 1.0, 12,  0, 2, 4, 16, 0, 127, 0, 255);
SliderElement E64  (0, 127,  66,  0, 16.0, 1.0, 12,  0, 6, 3, 15, 0, 127, 0, 255);

SliderElement E65  (0, 127,  68,  0, 16.0, 1.0, 12,  0, 6, 2, 12, 0, 127, 0, 255);
SliderElement E66  (0, 127,  70,  0, 16.0, 1.0, 12,  0, 6, 3, 14, 0, 127, 0, 255);
SliderElement E67  (0, 127,  72,  0, 16.0, 1.0, 12,  0, 6, 4, 12, 0, 127, 0, 255);
SliderElement E68  (0, 127,  89,  0, 16.0, 1.0, 20,  0, 7, 2, 10, 0, 127, 0, 255);
SliderElement E69  (0, 127,  95,  0, 16.0, 1.0, 21,  0, 3, 3, 10, 0, 127, 0, 255);
SliderElement E70  (0, 127,  103, 0, 16.0, 1.0, 22,  0, 2, 3, 10, 0, 127, 0, 255);
SliderElement E71  (0, 127,  121, 0, 16.0, 1.0, 13,  0, 3, 3, 10, 0, 127, 0, 255);
SliderElement E72  (0, 127,  22,  0, 16.0, 1.0, 14,  0, 3, 3, 10, 0, 127, 0, 255);

SliderElement E73  (0, 127,  24,  0, 16.0, 1.0, 12,  0, 3, 4, 10, 0, 127, 0, 255);
SliderElement E74  (0, 127,  26,  0, 16.0, 1.0, 11,  0, 4, 4, 10, 0, 127, 0, 255);
SliderElement E75  (0, 127,  28,  0, 16.0, 1.0, 10,  0, 4, 4, 10, 0, 127, 0, 255);
SliderElement E76  (0, 127,  30,  0, 16.0, 1.0, 10,  0, 5, 4, 10, 0, 127, 0, 255);
SliderElement E77  (0, 127,  32,  0, 16.0, 1.0, 27,  0, 1, 2, 40, 0, 127, 0, 255);
SliderElement E78  (0, 127,  34,  0, 16.0, 1.0, 26,  0, 2, 2, 40, 0, 127, 0, 255);
SliderElement E79  (0, 127,  36,  0, 16.0, 1.0, 25,  0, 3, 2, 40, 0, 127, 0, 255);
SliderElement E80  (0, 127,  38,  0, 16.0, 1.0, 24,  0, 4, 2, 40, 0, 127, 0, 255);


SliderElement *SLIDER_ELEMENTS[] {&E1, &E2, &E3, &E4, &E5, &E6, &E7, &E8, &E9, &E10, &E11, &E12, &E13, &E14, &E15, &E16, &E17, &E18, &E19,
                &E20, &E21, &E22, &E23, &E24, &E25, &E26, &E27, &E28, &E29, &E30, &E31, &E32, &E33, &E34, &E35, &E36, &E37, &E38, &E39,
                &E40, &E41, &E42, &E43, &E44, &E45, &E46, &E47, &E48, &E49, &E50, &E51, &E52, &E53, &E54, &E55, &E56, &E57, &E58, &E59,
                &E60, &E61, &E62, &E63, &E64, &E65, &E66, &E67, &E68, &E69, &E70, &E71, &E72, &E73, &E74, &E75, &E76, &E77, &E78, &E79, &E80
};
//****************Slider Name STRUCT
// Why a struct? simple, coz I havent figured out how to use the above for this yet
// Anyway, first time I've used one so for the sake of learning.. Thanks to @EconJack's book.
// I like the class idea, looks like a good place to weed out any out of range values
// induced by typos in SliderElement defs.
// Would be preferable to do this tacked onto the above. More logical layout.
// Stuff gets repeated - quick and dirty way to populate and proceed with
// getting the engine ticking over smoothly before fussing over the paint job.
struct SliderNames {
  char LowerName[7]; char UpperName[7];
};
struct SliderNames NameList[81] = {
  {"Filter", "ATTACK"},
  {"Filter", " DECAY"},
  {"Filter", " SUST "},
  {"Filter", "RELEAS"},
  {"Filter", "DEPTH "},
  {"Filter", "KEYFLW"},
  {"Filter", "CUTOFF"},
  {"Filter", " RESO "},

  {" Ampl ", "ATTACK"},
  {" Ampl ", " DECAY"},
  {" Ampl ", " SUST "},
  {" Ampl ", "RELEAS"},
  {"Lfo 1 ", "DEPTH "},
  {"CTRL1 ", "KEYFLW"},
  {"CTRL2 ", "CUTOFF"},
  {"CTRL3 ", " RESO "},

  {" CC#  ", "  24  "},
  {" CC#  ", "  25  "},
  {" CC#  ", "  26  "},
  {" CC#  ", "  27  "},
  {" CC#  ", "  28  "},
  {" CC#  ", "  29  "},
  {" Cc#  ", "  30  "},
  {" CC#  ", "  31  "},

  {" Ampl ", "ATTACK"},
  {" Ampl ", " DECAY"},
  {" Ampl ", " SUST "},
  {" Ampl ", "RELEAS"},
  {"Lfo 1 ", "DEPTH "},
  {"CTRL1 ", "KEYFLW"},
  {"CTRL2 ", "CUTOFF"},
  {"CTRL3 ", " RESO "},

  {"Filter", "ATTACK"},
  {"Filter", " DECAY"},
  {"Filter", " SUST "},
  {"Filter", "RELEAS"},
  {"Filter", "DEPTH "},
  {"Filter", "KEYFLW"},
  {"Filter", "CUTOFF"},
  {"Filter", " RESO "},

  {" Ampl ", "ATTACK"},
  {" Ampl ", " DECAY"},
  {" Ampl ", " SUST "},
  {" Ampl ", "RELEAS"},
  {"Lfo 1 ", "DEPTH "},
  {"CTRL1 ", "KEYFLW"},
  {"CTRL2 ", "CUTOFF"},
  {"CTRL3 ", " RESO "},

  {" CC#  ", "  24  "},
  {" CC#  ", "  25  "},
  {" CC#  ", "  26  "},
  {" CC#  ", "  27  "},
  {" CC#  ", "  28  "},
  {" CC#  ", "  29  "},
  {" Cc#  ", "  30  "},
  {" CC#  ", "  31  "},

  {" Ampl ", "ATTACK"},
  {" Ampl ", " DECAY"},
  {" Ampl ", " SUST "},
  {" Ampl ", "RELEAS"},
  {"Lfo 1 ", "DEPTH "},
  {"CTRL1 ", "KEYFLW"},
  {"CTRL2 ", "CUTOFF"},
  {"CTRL3 ", " RESO "},

  {" CC#  ", "  24  "},
  {" CC#  ", "  25  "},
  {" CC#  ", "  26  "},
  {" CC#  ", "  27  "},
  {" CC#  ", "  28  "},
  {" CC#  ", "  29  "},
  {" Cc#  ", "  30  "},
  {" CC#  ", "  31  "},

  {" Ampl ", "ATTACK"},
  {" Ampl ", " DECAY"},
  {" Ampl ", " SUST "},
  {" Ampl ", "RELEAS"},
  {"Lfo 1 ", "DEPTH "},
  {"CTRL1 ", "KEYFLW"},
  {"CTRL2 ", "CUTOFF"},
  {"CTRL3 ", " RESO "}


};
//********************************colorList********************************
// Probably redundant. Was implented to make sure I was sending these HEX values
// found in the .h

uint16_t colorList[36] = {

  0x0000, //  C_BLACK
  0x001F, //  C_BLUE
  0xF800, //  C_RED
  0X07E0, //  C_GREEN
  0x07FF, //  C_CYAN
  0xF81F, //  C_MAGENTA
  0xFFE0, //  C_YELLOW
  0xFFFF, //  C_WHITE
  0xB6DF, //  C_LTBLUE
  0xBF5F, //  C_LTEAL
  0xBFF7, //  C_LTGREEN
  0xC7FF, //  LT_CYAN
  0xFD34, //  LT_RED
  0xFD5F, //  LT_MAGENTA
  0xFFF8, //  LT_YELLOW
  0xFE73, //  LT_ORANGE
  0xFDDF, //  LT_PINK
  0xCCFF, //  LT_PURPLE
  0xE71C, //  LT_GREY
  0x0438, //  C_TEAL
  0xFD20, //  C_ORANGE
  0xF81F, //  C_LTPINK
  0x801F, //  C_PURPLE
  0xC618, //  C_GREY
  0x000D, //  C_DKBLUE
  0x020C, //  C_DKTEAL
  0x03E0, //  C_DK_GREEN
  0x03EF, //  C_DKCYAN
  0x6000, //  C_DKRED
  0x8008, //  C_DKMAGENTA
  0x8400, //  C_DKYELLOW
  0x8200, //  C_DKORANGE
  0x9009, //  C_DKPINK
  0x4010, //  C_DKPURPLE
  0x3186, //  C_DKGREY
  0x7BCF  //  C_MDGREY

};
//*****************************************************************

#define ROW1 70
#define ROW2 110
#define ROW3 150
#define ROW4 190

#define BAND1 20
#define BAND2 60
#define BAND3 100
#define BAND4 140
#define BAND5 180
#define BAND6 220
#define BAND7 260
#define BAND8 300
#define BAND9 20
#define BAND10 60
#define BAND11 100
#define BAND12 140
#define BAND13 180
#define BAND14 220
#define BAND15 260
#define BAND16 300

// Values are pulled in from SliderElements
//float TickSetting = 16.0;
//float SnapSetting = 1.0;

// some color defs
#define SLIDECOLOR C_GREY
#define HANDLECOLOR C_ORANGE
#define BACKCOLOR BackColor
#define TEXTCOLOR C_WHITE

//****************************************

#define ROW_1_TOP 6
#define ROW_1_HEIGHT 160
#define ROW_2_TOP 122
#define ROW_2_HEIGHT 80

#define VALUE_OFFSET_LEFT 8
#define TITLE_OFFSET_LEFT 23

// Create some band variables
// Values are pulled in from SliderElements

float Band1 ;
float Band2 ;
float Band3 ;
float Band4 ;
float Band5 ;
float Band6 ;
float Band7 ;
float Band8 ;

uint16_t BackColor = BackColor; // Kept this as there's no point changing
// handle BackColor against some other background color
int BtnX, BtnY;
//**********************************************************
// create display and DS objects
ILI9341_t3 Display = ILI9341_t3(TFT_CS, TFT_DC);
UTouch  Touch( TOUCH_CLK, TOUCH_CS, TOUCH_DIN, TOUCH_DO, TOUCH_IRQ);
//***********************************************************
//Current lib
SliderV sBand1(&Display);// Maybe this is a likely place to choose instantiate with 
// HandleSize = 0  rather than the usual default handleSize = 16
// so as to not break example Multi-Screen - boots up with no handles after changing
// line56 in ILI9341_t3_Controls.h  to #define SLIDER_HANDLE_SIZE 0
SliderV sBand2(&Display);
SliderV sBand3(&Display);
SliderV sBand4(&Display);
SliderV sBand5(&Display);
SliderV sBand6(&Display);
SliderV sBand7(&Display);
SliderV sBand8(&Display);

//**************** Encoder Tool **********************
//Encoder crankup
unsigned lowerEncoderLag;
unsigned lowerEncoderValue;
constexpr unsigned lowerEncoder_A   = ENC_PINA; // Input for lower encoder A
constexpr unsigned lowerEncoder_B   = ENC_PINB; // Input for lower encoder B
elapsedMillis stopwatch = 0;
elapsedMillis stopwatch2 = 0;
elapsedMillis stopwatch3 = 0;
Encoder lowerEncoder;

//*********************************************
void setup() {
  delay(500);
  Serial.begin(9600);
  pinMode(LCD_PIN, OUTPUT);
  //********************* Single Encoder *****************************************
  lowerEncoder.begin(ENC_PINA, ENC_PINB, CountMode::quarter);// Block select
  lowerEncoder. setLimits(0, 9); lowerEncoder. setValue(0);
  //********************* Multiplexed Encoders ***********************************
  int encoderData[encoderCount];
  int encoderDataLag[encoderCount];// when lag and new are not the same then do whatever
  encoders.begin(CountMode::full);
  //****************************************************************************
  Display.begin();
  Touch.InitTouch(PORTRAIT);
  Touch.setPrecision(PREC_EXTREME);
  Display.invertDisplay(false);
  Display.fillScreen(BACKCOLOR);
  Display.setRotation(Rotation);
  analogWrite(LCD_PIN, 255);
  InitSliders();
  DrawSliders();
}
//**********************************************************

void loop() {
  encoders.tick(); // MUXed encs
  doEncoder();     // single Block select enc
  ReadEncoders();
  DisplayEncoders();
  ProcessTouch();
}
//************ Initialize User interface **************
//void SliderV::init(uint16_t SliderX, uint16_t SliderY, uint16_t SliderH, float ScaleLow, float ScaleHi, float ScaleSize, float SnapSize,uint16_t SliderColor, uint16_t BackgroundColor, uint16_t HandleColor ) {

void InitSliders() {
  Display.fillScreen(BackColor);//TODO: Yuk! erase handles before initing a new block
  SLIDER_ELEMENTS[0 + ElementOffset]-> getSliderElementValues();
  Band1 = SLIDER_ELEMENTS[0 + ElementOffset]->EcurrVal;
  encoders[0].setValue((SLIDER_ELEMENTS[0 + ElementOffset]->EcurrVal));
  encoders[0]. setLimits(SLIDER_ELEMENTS[0 + ElementOffset]->EminVal, SLIDER_ELEMENTS[0 + ElementOffset]->EmaxVal);
  sBand1. init (BAND1,  ROW_1_TOP, ROW_1_HEIGHT,  SLIDER_ELEMENTS[0 + ElementOffset]->EminVal, SLIDER_ELEMENTS[0 + ElementOffset]->EmaxVal,
                SLIDER_ELEMENTS[0 + ElementOffset]->Etick, SLIDER_ELEMENTS[0 + ElementOffset]->Esnap, colorList[SLIDER_ELEMENTS[0 + ElementOffset]->EslideColor],
                BackColor, colorList[SLIDER_ELEMENTS[0 + ElementOffset]->EhandleColor]);
  sBand1.setHandleShape(SLIDER_ELEMENTS[0 + ElementOffset]->EhandleShape);
  sBand1.setHandleSize(SLIDER_ELEMENTS[0 + ElementOffset]->EhandleSize);
  sBand1.drawSliderColor(true);
  sBand1.draw(Band1);


  SLIDER_ELEMENTS[1 + ElementOffset]-> getSliderElementValues();
  Band2 = SLIDER_ELEMENTS[1 + ElementOffset]->EcurrVal;
  encoders[1].setValue(SLIDER_ELEMENTS[1 + ElementOffset]->EcurrVal);
  encoders[1]. setLimits(SLIDER_ELEMENTS[1 + ElementOffset]->EminVal, SLIDER_ELEMENTS[1 + ElementOffset]->EmaxVal);
  sBand2. init (BAND2,  ROW_1_TOP, ROW_1_HEIGHT,  SLIDER_ELEMENTS[1 + ElementOffset]->EminVal, SLIDER_ELEMENTS[1 + ElementOffset]->EmaxVal,
                SLIDER_ELEMENTS[1 + ElementOffset]->Etick, SLIDER_ELEMENTS[1 + ElementOffset]->Esnap, colorList[SLIDER_ELEMENTS[1 + ElementOffset]->EslideColor],
                BackColor, colorList[SLIDER_ELEMENTS[1 + ElementOffset]->EhandleColor]);
  sBand2.setHandleShape(SLIDER_ELEMENTS[1 + ElementOffset]->EhandleShape);
  sBand2.setHandleSize(SLIDER_ELEMENTS[1 + ElementOffset]->EhandleSize);
  sBand2.drawSliderColor(true);
  sBand2.draw(Band2);

  SLIDER_ELEMENTS[2 + ElementOffset]-> getSliderElementValues();
  Band3 = SLIDER_ELEMENTS[2 + ElementOffset]->EcurrVal;
  encoders[2].setValue(SLIDER_ELEMENTS[2 + ElementOffset]->EcurrVal);
  encoders[2]. setLimits(SLIDER_ELEMENTS[2 + ElementOffset]->EminVal, SLIDER_ELEMENTS[2 + ElementOffset]->EmaxVal);
  sBand3. init (BAND3,  ROW_1_TOP, ROW_1_HEIGHT,  SLIDER_ELEMENTS[2 + ElementOffset]->EminVal, SLIDER_ELEMENTS[2 + ElementOffset]->EmaxVal,
                SLIDER_ELEMENTS[2 + ElementOffset]->Etick, SLIDER_ELEMENTS[2 + ElementOffset]->Esnap, colorList[SLIDER_ELEMENTS[2 + ElementOffset]->EslideColor],
                BackColor, colorList[SLIDER_ELEMENTS[2 + ElementOffset]->EhandleColor]);
  sBand3.setHandleShape(SLIDER_ELEMENTS[2 + ElementOffset]->EhandleShape);
  sBand3.setHandleSize(SLIDER_ELEMENTS[2 + ElementOffset]->EhandleSize);
  sBand3.drawSliderColor(true);
  sBand3.draw(Band3);

  SLIDER_ELEMENTS[3 + ElementOffset]-> getSliderElementValues();
  Band4 = SLIDER_ELEMENTS[3 + ElementOffset]->EcurrVal;
  encoders[3].setValue(SLIDER_ELEMENTS[3 + ElementOffset]->EcurrVal);
  encoders[3]. setLimits(SLIDER_ELEMENTS[3 + ElementOffset]->EminVal, SLIDER_ELEMENTS[3 + ElementOffset]->EmaxVal);
  sBand4. init (BAND4,  ROW_1_TOP, ROW_1_HEIGHT,  SLIDER_ELEMENTS[3 + ElementOffset]->EminVal, SLIDER_ELEMENTS[3 + ElementOffset]->EmaxVal,
                SLIDER_ELEMENTS[3 + ElementOffset]->Etick, SLIDER_ELEMENTS[3 + ElementOffset]->Esnap, colorList[SLIDER_ELEMENTS[3 + ElementOffset]->EslideColor],
                BackColor, colorList[SLIDER_ELEMENTS[3 + ElementOffset]->EhandleColor]);
  sBand4.setHandleShape(SLIDER_ELEMENTS[3 + ElementOffset]->EhandleShape);
  sBand4.setHandleSize(SLIDER_ELEMENTS[3 + ElementOffset]->EhandleSize);
  sBand4.drawSliderColor(true);
  sBand4.draw(Band4);

  SLIDER_ELEMENTS[4 + ElementOffset]-> getSliderElementValues();
  Band5 = SLIDER_ELEMENTS[4 + ElementOffset]->EcurrVal;
  encoders[4].setValue(SLIDER_ELEMENTS[4 + ElementOffset]->EcurrVal);
  encoders[4]. setLimits(SLIDER_ELEMENTS[4 + ElementOffset]->EminVal, SLIDER_ELEMENTS[4 + ElementOffset]->EmaxVal);
  sBand5. init (BAND5,  ROW_1_TOP, ROW_1_HEIGHT,  SLIDER_ELEMENTS[4 + ElementOffset]->EminVal, SLIDER_ELEMENTS[4 + ElementOffset]->EmaxVal,
                SLIDER_ELEMENTS[4 + ElementOffset]->Etick, SLIDER_ELEMENTS[4 + ElementOffset]->Esnap,  colorList[SLIDER_ELEMENTS[4 + ElementOffset]->EslideColor],
                BackColor, colorList[SLIDER_ELEMENTS[4 + ElementOffset]->EhandleColor]);
  sBand5.setHandleShape(SLIDER_ELEMENTS[4 + ElementOffset]->EhandleShape);
  sBand5.setHandleSize(SLIDER_ELEMENTS[4 + ElementOffset]->EhandleSize);
  sBand5.drawSliderColor(true);
  sBand5.draw(Band4);

  SLIDER_ELEMENTS[5 + ElementOffset]-> getSliderElementValues();
  Band6 = SLIDER_ELEMENTS[5 + ElementOffset]->EcurrVal;
  encoders[5]. setLimits(SLIDER_ELEMENTS[5 + ElementOffset]->EminVal, SLIDER_ELEMENTS[5 + ElementOffset]->EmaxVal);
  encoders[5].setValue(SLIDER_ELEMENTS[5 + ElementOffset]->EcurrVal);
  sBand6. init (BAND6,  ROW_1_TOP, ROW_1_HEIGHT,  SLIDER_ELEMENTS[5 + ElementOffset]->EminVal, SLIDER_ELEMENTS[5 + ElementOffset]->EmaxVal,
                SLIDER_ELEMENTS[5 + ElementOffset]->Etick, SLIDER_ELEMENTS[5 + ElementOffset]->Esnap,  colorList[SLIDER_ELEMENTS[5 + ElementOffset]->EslideColor],
                BackColor, colorList[SLIDER_ELEMENTS[5 + ElementOffset]->EhandleColor]);
  sBand6.setHandleShape(SLIDER_ELEMENTS[5 + ElementOffset]->EhandleShape);
  sBand6.setHandleSize(SLIDER_ELEMENTS[5 + ElementOffset]->EhandleSize);
  sBand6.drawSliderColor(true);
  sBand6.draw(Band6);

  SLIDER_ELEMENTS[6 + ElementOffset]-> getSliderElementValues();
  Band7 = SLIDER_ELEMENTS[6 + ElementOffset]->EcurrVal;
  encoders[6]. setLimits(SLIDER_ELEMENTS[6 + ElementOffset]->EminVal, SLIDER_ELEMENTS[6 + ElementOffset]->EmaxVal);
  encoders[6].setValue(SLIDER_ELEMENTS[6 + ElementOffset]->EcurrVal);
  sBand7. init (BAND7,  ROW_1_TOP, ROW_1_HEIGHT,  SLIDER_ELEMENTS[6 + ElementOffset]->EminVal, SLIDER_ELEMENTS[6 + ElementOffset]->EmaxVal,
                SLIDER_ELEMENTS[6 + ElementOffset]->Etick, SLIDER_ELEMENTS[6 + ElementOffset]->Esnap, colorList[SLIDER_ELEMENTS[6 + ElementOffset]->EslideColor],
                BackColor, colorList[SLIDER_ELEMENTS[6 + ElementOffset]->EhandleColor]);
  sBand7.setHandleShape(SLIDER_ELEMENTS[6 + ElementOffset]->EhandleShape);
  sBand7.setHandleSize(SLIDER_ELEMENTS[6 + ElementOffset]->EhandleSize);
  sBand7.drawSliderColor(true);
  sBand7.draw(Band7);

  SLIDER_ELEMENTS[7 + ElementOffset]-> getSliderElementValues();
  Band8 = SLIDER_ELEMENTS[7 + ElementOffset]->EcurrVal;
  encoders[7]. setLimits(SLIDER_ELEMENTS[7 + ElementOffset]->EminVal, SLIDER_ELEMENTS[7 + ElementOffset]->EmaxVal);
  encoders[7].setValue(SLIDER_ELEMENTS[7 + ElementOffset]->EcurrVal);
  sBand8. init (BAND8,  ROW_1_TOP, ROW_1_HEIGHT,  SLIDER_ELEMENTS[7 + ElementOffset]->EminVal, SLIDER_ELEMENTS[7 + ElementOffset]->EmaxVal,
                SLIDER_ELEMENTS[7 + ElementOffset]->Etick, SLIDER_ELEMENTS[7 + ElementOffset]->Esnap, colorList[SLIDER_ELEMENTS[6 + ElementOffset]->EslideColor],
                BackColor, colorList[SLIDER_ELEMENTS[7 + ElementOffset]->EhandleColor]);
  sBand8.setHandleShape(SLIDER_ELEMENTS[7 + ElementOffset]->EhandleShape);
  sBand8.setHandleSize(SLIDER_ELEMENTS[7 + ElementOffset]->EhandleSize);
  sBand8.drawSliderColor(true);

}
//**************************************************************

void DrawSliders() {
  char buf[4];
  SLIDER_ELEMENTS[0 + ElementOffset]-> getSliderElementValues();
  Display.fillRect (BAND1 - VALUE_OFFSET_LEFT, ROW_1_TOP + ROW_1_HEIGHT + 6, BAND2 - BAND1, 10, BACKCOLOR);
  sprintf(buf, "% 3d", (int) (SLIDER_ELEMENTS[0 + ElementOffset]->EcurrVal));

  Display.setCursor(BAND1 - VALUE_OFFSET_LEFT , ROW_1_TOP + ROW_1_HEIGHT + 6); Display.print((int) (SLIDER_ELEMENTS[0 + ElementOffset]->EcurrVal));
  Display.setCursor(BAND1  - TITLE_OFFSET_LEFT , ROW_1_TOP + ROW_1_HEIGHT + 16); Display.print((NameList[0 + ElementOffset].UpperName));
  Display.setCursor(BAND1  - TITLE_OFFSET_LEFT , ROW_1_TOP + ROW_1_HEIGHT + 26); Display.print((NameList[0 + ElementOffset].LowerName));
// Playing with the differences here. Some TODO here to blank the entire text area before changing Blocks otherwise
// yukky ClearScreen needed to clean up the mess
  /*
    SLIDER_ELEMENTS[0 + ElementOffset]-> getSliderElementValues();
    Display.fillRect (BAND1 - VALUE_OFFSET_LEFT, ROW_1_TOP + ROW_1_HEIGHT + 6, BAND2 - BAND1, 10, BACKCOLOR);
    Display.setCursor(BAND1 - VALUE_OFFSET_LEFT , ROW_1_TOP + ROW_1_HEIGHT + 6); Display.print(SLIDER_ELEMENTS[0 + ElementOffset]->EcurrVal);
    Display.setCursor(BAND1  - TITLE_OFFSET_LEFT , ROW_1_TOP + ROW_1_HEIGHT + 16); Display.print((NameList[0 + ElementOffset].UpperName));
    Display.setCursor(BAND1  - TITLE_OFFSET_LEFT , ROW_1_TOP + ROW_1_HEIGHT + 26); Display.print((NameList[0 + ElementOffset].LowerName));
  */
  SLIDER_ELEMENTS[1 + ElementOffset]-> getSliderElementValues();
  Display.fillRect (BAND2 - VALUE_OFFSET_LEFT, ROW_1_TOP + ROW_1_HEIGHT + 6, BAND3 - BAND2, 10, BACKCOLOR);
  Display.setCursor(BAND2 - VALUE_OFFSET_LEFT , ROW_1_TOP + ROW_1_HEIGHT + 6); Display.print(SLIDER_ELEMENTS[1 + ElementOffset]->EcurrVal);
  Display.setCursor(BAND2 - TITLE_OFFSET_LEFT , ROW_1_TOP + ROW_1_HEIGHT + 16); Display.print((NameList[1 + ElementOffset].UpperName));
  Display.setCursor(BAND2 - TITLE_OFFSET_LEFT , ROW_1_TOP + ROW_1_HEIGHT + 26); Display.print((NameList[1 + ElementOffset].LowerName));

  SLIDER_ELEMENTS[2 + ElementOffset]-> getSliderElementValues();
  Display.fillRect (BAND3 - VALUE_OFFSET_LEFT, ROW_1_TOP + ROW_1_HEIGHT + 6, BAND4 - BAND3, 10, BACKCOLOR);
  Display.setCursor(BAND3 - VALUE_OFFSET_LEFT , ROW_1_TOP + ROW_1_HEIGHT + 6); Display.print(SLIDER_ELEMENTS[2 + ElementOffset]->EcurrVal);
  Display.setCursor(BAND3 - TITLE_OFFSET_LEFT , ROW_1_TOP + ROW_1_HEIGHT + 16); Display.print((NameList[2 + ElementOffset].UpperName));
  Display.setCursor(BAND3 - TITLE_OFFSET_LEFT , ROW_1_TOP + ROW_1_HEIGHT + 26); Display.print((NameList[2 + ElementOffset].LowerName));

  SLIDER_ELEMENTS[3 + ElementOffset]-> getSliderElementValues();
  Display.fillRect (BAND4 - VALUE_OFFSET_LEFT, ROW_1_TOP + ROW_1_HEIGHT + 6, BAND5 - BAND4, 10, BACKCOLOR);
  Display.setCursor(BAND4 - VALUE_OFFSET_LEFT , ROW_1_TOP + ROW_1_HEIGHT + 6); Display.print(SLIDER_ELEMENTS[3 + ElementOffset]->EcurrVal);
  Display.setCursor(BAND4 - TITLE_OFFSET_LEFT , ROW_1_TOP + ROW_1_HEIGHT + 16); Display.print((NameList[3 + ElementOffset].UpperName));
  Display.setCursor(BAND4 - TITLE_OFFSET_LEFT , ROW_1_TOP + ROW_1_HEIGHT + 26); Display.print((NameList[3 + ElementOffset].LowerName));

  SLIDER_ELEMENTS[4 + ElementOffset]-> getSliderElementValues();
  Display.fillRect (BAND5 - VALUE_OFFSET_LEFT, ROW_1_TOP + ROW_1_HEIGHT + 6, BAND6 - BAND5, 10, BACKCOLOR);
  Display.setCursor(BAND5 - VALUE_OFFSET_LEFT , ROW_1_TOP + ROW_1_HEIGHT + 6); Display.print(SLIDER_ELEMENTS[4 + ElementOffset]->EcurrVal);
  Display.setCursor(BAND5 - TITLE_OFFSET_LEFT , ROW_1_TOP + ROW_1_HEIGHT + 16); Display.print((NameList[4 + ElementOffset].UpperName));
  Display.setCursor(BAND5 - TITLE_OFFSET_LEFT , ROW_1_TOP + ROW_1_HEIGHT + 26); Display.print((NameList[4 + ElementOffset].LowerName));

  SLIDER_ELEMENTS[5 + ElementOffset]-> getSliderElementValues();
  Display.fillRect (BAND6 - VALUE_OFFSET_LEFT, ROW_1_TOP + ROW_1_HEIGHT + 6, BAND7 - BAND6, 10, BACKCOLOR);
  Display.setCursor(BAND6 - VALUE_OFFSET_LEFT , ROW_1_TOP + ROW_1_HEIGHT + 6); Display.print(SLIDER_ELEMENTS[5 + ElementOffset]->EcurrVal);
  Display.setCursor(BAND6 - TITLE_OFFSET_LEFT , ROW_1_TOP + ROW_1_HEIGHT + 16); Display.print((NameList[5 + ElementOffset].UpperName));
  Display.setCursor(BAND6 - TITLE_OFFSET_LEFT , ROW_1_TOP + ROW_1_HEIGHT + 26); Display.print((NameList[5 + ElementOffset].LowerName));

  SLIDER_ELEMENTS[6 + ElementOffset]-> getSliderElementValues();
  Display.fillRect (BAND7 - VALUE_OFFSET_LEFT, ROW_1_TOP + ROW_1_HEIGHT + 6, BAND8 - BAND7, 10, BACKCOLOR);
  Display.setCursor(BAND7 - VALUE_OFFSET_LEFT , ROW_1_TOP + ROW_1_HEIGHT + 6); Display.print(SLIDER_ELEMENTS[6 + ElementOffset]->EcurrVal);
  Display.setCursor(BAND7 - TITLE_OFFSET_LEFT , ROW_1_TOP + ROW_1_HEIGHT + 16); Display.print((NameList[6 + ElementOffset].UpperName));
  Display.setCursor(BAND7 - TITLE_OFFSET_LEFT , ROW_1_TOP + ROW_1_HEIGHT + 26); Display.print((NameList[6 + ElementOffset].LowerName));

  SLIDER_ELEMENTS[7 + ElementOffset]-> getSliderElementValues();
  Display.fillRect (BAND8 - VALUE_OFFSET_LEFT, ROW_1_TOP + ROW_1_HEIGHT + 6, BAND9 - BAND8, 10, BACKCOLOR);
  Display.setCursor(BAND8 - VALUE_OFFSET_LEFT , ROW_1_TOP + ROW_1_HEIGHT + 6); Display.print(SLIDER_ELEMENTS[7 + ElementOffset]->EcurrVal);
  Display.setCursor(BAND8 - TITLE_OFFSET_LEFT , ROW_1_TOP + ROW_1_HEIGHT + 16); Display.print((NameList[7 + ElementOffset].UpperName));
  Display.setCursor(BAND8 - TITLE_OFFSET_LEFT , ROW_1_TOP + ROW_1_HEIGHT + 26); Display.print((NameList[7 + ElementOffset].LowerName));
}

//************** Read Block Select encoder ************************

void doEncoder() {
  if (stopwatch2 > 10)
  {
    lowerEncoderValue = lowerEncoder.getValue();
    if (lowerEncoderValue != lowerEncoderLag)
    {
      lowerEncoderLag = lowerEncoderValue;
      ElementOffset = lowerEncoderValue*8;
//      Display.fillScreen(BACKCOLOR);

      InitSliders();
      DrawSliders();
    }
    stopwatch2 = 0;
  }
}
//******************************************

void UpdateEncoders() {
  for (unsigned i = 0; i <= encoderCount; i++)
  {
    encoderData[i] = (encoders[i].getValue());
  }
}
//******************************************

void DisplayEncoders() {

  if    (encoderData[0] != encoderDataLag[0])
  {
    encoderDataLag[0] = encoderData[0];
    SLIDER_ELEMENTS[0 + ElementOffset]-> getSliderElementValues();
    SLIDER_ELEMENTS[0 + ElementOffset]->EcurrVal = (encoderData[0]);
    Display.fillRect (BAND1 - VALUE_OFFSET_LEFT , ROW_1_TOP + ROW_1_HEIGHT + 6, BAND2 - BAND1, 10, BACKCOLOR);
    Display.setCursor(BAND1 - VALUE_OFFSET_LEFT , ROW_1_TOP + ROW_1_HEIGHT + 6); Display.print((int)(encoderData[0]));
    sBand1.value = (int)(encoderData[0]);
    sBand1.draw ((int)(encoderData[0]));//
  }
  else if    (encoderData[1] != encoderDataLag[1])
  {
    encoderDataLag[1] = encoderData[1];
    Band2 = (encoderData[1]);
    SLIDER_ELEMENTS[1 + ElementOffset]-> getSliderElementValues();
    SLIDER_ELEMENTS[1 + ElementOffset]->EcurrVal = (encoderData[1]);
    Display.fillRect (BAND2 - VALUE_OFFSET_LEFT , ROW_1_TOP + ROW_1_HEIGHT + 6, BAND3 - BAND2, 10, BACKCOLOR);
    Display.setCursor(BAND2 - VALUE_OFFSET_LEFT , ROW_1_TOP + ROW_1_HEIGHT + 6); Display.print((int)(encoderData[1]));
    sBand2.value = (int)(encoderData[1]);
    sBand2.draw ((int)(encoderData[1]));//(Band2);
  }
  else if    (encoderData[2] != encoderDataLag[2])
  {
    encoderDataLag[2] = encoderData[2];
    SLIDER_ELEMENTS[2 + ElementOffset]-> getSliderElementValues();
    SLIDER_ELEMENTS[2 + ElementOffset]->EcurrVal = (encoderData[2]);
    Display.fillRect (BAND3 - VALUE_OFFSET_LEFT , ROW_1_TOP + ROW_1_HEIGHT + 6, BAND4 - BAND3, 10, BACKCOLOR);
    Display.setCursor(BAND3 - VALUE_OFFSET_LEFT , ROW_1_TOP + ROW_1_HEIGHT + 6); Display.print((int)(encoderData[2]));
    sBand3.value = (int)(encoderData[2]);
    sBand3.draw ((int)(encoderData[2]));//(encoderData[2]);
  }
  else if    (encoderData[3] != encoderDataLag[3])

  {
    encoderDataLag[3] = encoderData[3];
    SLIDER_ELEMENTS[3 + ElementOffset]-> getSliderElementValues();
    SLIDER_ELEMENTS[3 + ElementOffset]->EcurrVal = (encoderData[3]);
    Display.fillRect (BAND4 - VALUE_OFFSET_LEFT , ROW_1_TOP + ROW_1_HEIGHT + 6, BAND5 - BAND4, 10, BACKCOLOR);
    Display.setCursor(BAND4 - VALUE_OFFSET_LEFT , ROW_1_TOP + ROW_1_HEIGHT + 6); Display.print((int)(encoderData[3]));
    sBand4.value = (int)(encoderData[3]);
    sBand4.draw ((int)(encoderData[3]));//(encoderData[3]);
  }
  else if    (encoderData[4] != encoderDataLag[4])
  {
    encoderDataLag[4] = encoderData[4];
    SLIDER_ELEMENTS[4 + ElementOffset]-> getSliderElementValues();
    SLIDER_ELEMENTS[4 + ElementOffset]->EcurrVal = (encoderData[4]);
    Display.fillRect (BAND5 - VALUE_OFFSET_LEFT , ROW_1_TOP + ROW_1_HEIGHT + 6, BAND5 - BAND4, 10, BACKCOLOR);
    Display.setCursor(BAND5 - VALUE_OFFSET_LEFT , ROW_1_TOP + ROW_1_HEIGHT + 6); Display.print((int)(encoderData[4]));
    sBand5.value = (int)(encoderData[4]);
    sBand5.draw ((int)(encoderData[4]));//(encoderData[4]);
  }
  else if    (encoderData[5] != encoderDataLag[5])
  {
    encoderDataLag[5] = encoderData[5];
    SLIDER_ELEMENTS[5 + ElementOffset]-> getSliderElementValues();
    SLIDER_ELEMENTS[5 + ElementOffset]->EcurrVal = (encoderData[5]);
    Display.fillRect (BAND6 - VALUE_OFFSET_LEFT , ROW_1_TOP + ROW_1_HEIGHT + 6, BAND6 - BAND5, 10, BACKCOLOR);
    Display.setCursor(BAND6 - VALUE_OFFSET_LEFT , ROW_1_TOP + ROW_1_HEIGHT + 6); Display.print((int)(encoderData[5]));
    sBand6.value = (int)(encoderData[5]);
    sBand6.draw ((int)(encoderData[5]));//(encoderData[5]);
  }
  else if    (encoderData[6] != encoderDataLag[6])
  {
    encoderDataLag[6] = encoderData[6];
    SLIDER_ELEMENTS[6 + ElementOffset]-> getSliderElementValues();
    SLIDER_ELEMENTS[6 + ElementOffset]->EcurrVal = (encoderData[6]);
    Display.fillRect (BAND7 - VALUE_OFFSET_LEFT , ROW_1_TOP + ROW_1_HEIGHT + 6, BAND7 - BAND6, 10, BACKCOLOR);
    Display.setCursor(BAND7 - VALUE_OFFSET_LEFT , ROW_1_TOP + ROW_1_HEIGHT + 6); Display.print((int)(encoderData[6]));
    sBand7.value = (int)(encoderData[6]);
    sBand7.draw ((int)(encoderData[6]));//(encoderData[6]);
  }
  else if    (encoderData[7] != encoderDataLag[7])
  {
    encoderDataLag[7] = encoderData[7];
    SLIDER_ELEMENTS[7 + ElementOffset]-> getSliderElementValues();
    SLIDER_ELEMENTS[7 + ElementOffset]->EcurrVal = (encoderData[7]);
    Display.fillRect (BAND8 - VALUE_OFFSET_LEFT , ROW_1_TOP + ROW_1_HEIGHT + 6, BAND8 - BAND7, 10, BACKCOLOR);
    Display.setCursor(BAND8 - VALUE_OFFSET_LEFT , ROW_1_TOP + ROW_1_HEIGHT + 6); Display.print((int)(encoderData[7]));
    sBand8.value = (int)(encoderData[7]);
    sBand8.draw ((int)(encoderData[7]));
  }
}

//*************************************

void ProcessTouch() {
  if (Touch.dataAvailable()) {
    GetTouch();

    Band1 = sBand1.slide(BtnX, BtnY);
    Band2 = sBand2.slide(BtnX, BtnY);
    Band3 = sBand3.slide(BtnX, BtnY);
    Band4 = sBand4.slide(BtnX, BtnY);
    Band5 = sBand5.slide(BtnX, BtnY);
    Band6 = sBand6.slide(BtnX, BtnY);
    Band7 = sBand7.slide(BtnX, BtnY);
    Band8 = sBand8.slide(BtnX, BtnY);
    {
      if (sBand1.changed())
      {
        Display.fillRect (BAND1 - VALUE_OFFSET_LEFT, ROW_1_TOP + ROW_1_HEIGHT + 6, BAND2 - BAND1, 10, BACKCOLOR);
        Display.setCursor(BAND1 - VALUE_OFFSET_LEFT, ROW_1_TOP + ROW_1_HEIGHT + 6); Display.print((int)sBand1.value);//
        SLIDER_ELEMENTS[0 + ElementOffset]-> getSliderElementValues();
        SLIDER_ELEMENTS[0 + ElementOffset]->EcurrVal = ((int)sBand1.value);//(Band1);
        encoders[0].setValue ((int)(sBand1.value));//
      }
      else if (sBand2.changed()) {
        Display.fillRect (BAND2 - VALUE_OFFSET_LEFT, ROW_1_TOP + ROW_1_HEIGHT + 6, BAND3 - BAND2, 10, BACKCOLOR);
        Display.setCursor(BAND2 - VALUE_OFFSET_LEFT, ROW_1_TOP + ROW_1_HEIGHT + 6); Display.print((int)sBand2.value);//(Band2);
        SLIDER_ELEMENTS[1 + ElementOffset]-> getSliderElementValues();
        SLIDER_ELEMENTS[1 + ElementOffset]->EcurrVal = ((int)sBand2.value);//(Band2);
        encoders[1].setValue ((int)(sBand2.value));//(Band2);
      }
      else if (sBand3.changed()) {
        Display.fillRect (BAND3 - VALUE_OFFSET_LEFT, ROW_1_TOP + ROW_1_HEIGHT + 6, BAND4 - BAND3, 10, BACKCOLOR);
        Display.setCursor(BAND3 - VALUE_OFFSET_LEFT, ROW_1_TOP + ROW_1_HEIGHT + 6); Display.print((int)sBand3.value);//(Band3);
        SLIDER_ELEMENTS[2 + ElementOffset]-> getSliderElementValues();
        SLIDER_ELEMENTS[2 + ElementOffset]->EcurrVal = ((int)sBand3.value);//(Band3);
        encoders[2].setValue ((int)(sBand3.value));//(Band3);
      }
      else if (sBand4.changed()) {
        Display.fillRect (BAND4 - VALUE_OFFSET_LEFT, ROW_1_TOP + ROW_1_HEIGHT + 6, BAND5 - BAND4, 10, BACKCOLOR);
        Display.setCursor(BAND4 - VALUE_OFFSET_LEFT, ROW_1_TOP + ROW_1_HEIGHT + 6); Display.print((int)sBand4.value);//(Band4);
        SLIDER_ELEMENTS[3 + ElementOffset]-> getSliderElementValues();
        SLIDER_ELEMENTS[3 + ElementOffset]->EcurrVal = ((int)sBand4.value);//(Band4);
        encoders[3].setValue ((int)(sBand4.value));//(Band4);
      }
      else if (sBand5.changed()) {
        Display.fillRect (BAND5 - VALUE_OFFSET_LEFT, ROW_1_TOP + ROW_1_HEIGHT + 6, BAND6 - BAND5, 10, BACKCOLOR);
        Display.setCursor(BAND5 - VALUE_OFFSET_LEFT, ROW_1_TOP + ROW_1_HEIGHT + 6); Display.print((int)sBand6.value);//(Band5);
        SLIDER_ELEMENTS[4 + ElementOffset]-> getSliderElementValues();
        SLIDER_ELEMENTS[4 + ElementOffset]->EcurrVal = ((int)sBand5.value);//(Band5);
        encoders[4].setValue ((int)(sBand5.value));//(Band5);
      }
      else if (sBand6.changed()) {
        Display.fillRect (BAND6 - VALUE_OFFSET_LEFT, ROW_1_TOP + ROW_1_HEIGHT + 6, BAND7 - BAND6, 10, BACKCOLOR);
        Display.setCursor(BAND6 - VALUE_OFFSET_LEFT, ROW_1_TOP + ROW_1_HEIGHT + 6); Display.print((int)sBand7.value);//(Band6);
        SLIDER_ELEMENTS[5 + ElementOffset]-> getSliderElementValues();
        SLIDER_ELEMENTS[5 + ElementOffset]->EcurrVal = ((int)sBand6.value);//(Band6);
        encoders[5].setValue ((int)(sBand6.value));//(Band6);
      }
      else if (sBand7.changed()) {
        Display.fillRect (BAND7 - VALUE_OFFSET_LEFT, ROW_1_TOP + ROW_1_HEIGHT + 6, BAND8 - BAND7, 10, BACKCOLOR);
        Display.setCursor(BAND7 - VALUE_OFFSET_LEFT, ROW_1_TOP + ROW_1_HEIGHT + 6); Display.print((int)sBand7.value);//(Band7);
        SLIDER_ELEMENTS[6 + ElementOffset]-> getSliderElementValues();
        SLIDER_ELEMENTS[6 + ElementOffset]->EcurrVal = ((int)sBand7.value);//(Band7);
        encoders[6].setValue ((int)(sBand7.value));//(Band7);
      }
      else if (sBand8.changed()) {
        Display.fillRect (BAND8 - VALUE_OFFSET_LEFT, ROW_1_TOP + ROW_1_HEIGHT + 6, BAND9 - BAND8, 10, BACKCOLOR);
        Display.setCursor(BAND8 - VALUE_OFFSET_LEFT, ROW_1_TOP + ROW_1_HEIGHT + 6); Display.print((int)sBand8.value);//(Band8);
        SLIDER_ELEMENTS[7 + ElementOffset]-> getSliderElementValues();
        SLIDER_ELEMENTS[7 + ElementOffset]->EcurrVal = ((int)sBand8.value);//(Band8);
        encoders[7].setValue ((int)(sBand8.value));//(Band8);
      }
    }
  }
}
//********************************************************************
// my own processing function to handle press and convert to proper screen
// coordinates
// i've found so many differences between different screens, i needed an easy
// way to handle returning screen calcualtions
// my code uses global button x and button y locations
void GetTouch() {

  // depending on the touch library you may need to change methods here
  Touch.read();

  BtnX = Touch.getX();
  BtnY = Touch.getY();

  // consistency between displays is a mess...
  // this is some debug code to help show
  // where you pressed and the resulting map

  //Serial.print("real coordinates: ");
  //Serial.print(BtnX);
  //Serial.print(",");
  //Serial.println (BtnY);
  //Display.drawPixel(BtnX, BtnY, C_RED);

  //different values depending on where touch happened

  // x  = map(x, real left, real right, 0, 480);
  // y  = map(y, real bottom, real top, 320, 0);

#if defined USE_YELLOW_HEADERS
  // tft with yellow headers
  BtnX  = map(BtnX, 240, 0, 320, 0);
  BtnY  = map(BtnY, 379, 0, 240, 0);
#endif

#if defined USE_BLACK_HEADERS
  // tft with black headers
  BtnX  = map(BtnX, 0, 240, 320, 0);
  BtnY  = map(BtnY, 0, 380, 240, 0);
#endif

  // tft with yellow headers
  //BtnX  = map(BtnX, 240, 0, 320, 0);
  //BtnY  = map(BtnY, 379, 0, 240, 0);

  // tft with black headers
  //BtnX  = map(BtnX, 0, 240, 320, 0);
  //BtnY  = map(BtnY, 0, 380, 240, 0);

  //Serial.print(", Mapped coordinates: ");
  //Serial.print(BtnX);
  //Serial.print(",");
  //Serial.println(BtnY);
  //Display.drawPixel(BtnX, BtnY, C_GREEN);

}

//***************************************************************
void ReadEncoders() {
  int i;
  if (stopwatch > 20 ) // Populate EncoderData[] every so often
  {
    for (i = 0; i < 8; i++)
    {
      encoderData[i] = encoders[i].getValue();
    }
    stopwatch = 0;
  }
}
